import {
  addOtherMarker,
  isOtherValue,
  removeOtherMarker
} from "./chunk-BRZX66ZS.js";
import {
  __name,
  __objRest
} from "./chunk-B36FS7SS.js";

// components/form/inputs/Radiogroup.tsx
import React, { useState, useEffect } from "react";
import { FormCheck } from "react-bootstrap";
import isEmpty from "lodash/isEmpty.js";
import { useFormContext, useVulcanComponents } from "@vulcanjs/react-ui";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var OtherComponent = /* @__PURE__ */ __name(({ value, path }) => {
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const otherValue = removeOtherMarker(value);
  const [showOther, setShowOther] = useState(isOtherValue(value));
  const [textFieldValue, setTextFieldValue] = useState(otherValue);
  useEffect(() => {
    if (value) {
      setShowOther(isOtherValue(value));
    }
  }, [
    value
  ]);
  const textFieldInputProperties = {
    name: path,
    value: textFieldValue,
    onChange: (event) => {
      const fieldValue = event.target.value;
      setTextFieldValue(fieldValue);
      const newValue = isEmpty(fieldValue) ? null : addOtherMarker(fieldValue);
      updateCurrentValues({
        [path]: newValue
      });
    }
  };
  const textFieldItemProperties = {
    layout: "elementOnly"
  };
  return /* @__PURE__ */ React.createElement("div", {
    className: "form-option-other"
  }, /* @__PURE__ */ React.createElement(FormCheck, {
    name: path,
    layout: "elementOnly",
    label: "Other",
    value: showOther,
    checked: showOther,
    type: "radio",
    onClick: (event) => {
      const isChecked = event.target.checked;
      updateCurrentValues({
        [path]: null
      });
      setShowOther(isChecked);
    }
  }), showOther && /* @__PURE__ */ React.createElement(Components.FormComponentText, {
    inputProperties: textFieldInputProperties,
    itemProperties: textFieldItemProperties
  }));
}, "OtherComponent");
var FormComponentRadioGroup = /* @__PURE__ */ __name(({ refFunction, path, inputProperties, itemProperties = {} }) => {
  const Components = useVulcanComponents();
  const { updateCurrentValues } = useFormContext();
  const _a = inputProperties, { options = [], value } = _a, otherInputProperties = __objRest(_a, ["options", "value"]);
  const hasValue = value !== "";
  return /* @__PURE__ */ React.createElement(Components.FormItem, _extends({
    path,
    label: inputProperties.label
  }, itemProperties), options.map((option, i) => {
    const isChecked = value === option.value;
    const checkClass = hasValue ? isChecked ? "form-check-checked" : "form-check-unchecked" : "";
    return /* @__PURE__ */ React.createElement(FormCheck, _extends({}, otherInputProperties, {
      key: i,
      layout: "elementOnly",
      type: "radio",
      label: /* @__PURE__ */ React.createElement(Components.FormOptionLabel, {
        option
      }),
      value: option.value,
      name: path,
      id: `${path}.${i}`,
      path: `${path}.${i}`,
      ref: refFunction,
      checked: isChecked,
      className: checkClass
    }));
  }), itemProperties.showOther && /* @__PURE__ */ React.createElement(OtherComponent, {
    value,
    path
  }));
}, "FormComponentRadioGroup");

export {
  FormComponentRadioGroup
};
//# sourceMappingURL=chunk-6CLWM4WG.js.map