import {
  Alert
} from "./chunk-ZHEVR72Q.js";
import {
  Button
} from "./chunk-2NSMPVVD.js";
import {
  TooltipTrigger
} from "./chunk-ZJIMZ34L.js";
import {
  FormattedMessage,
  require_prop_types
} from "./chunk-JVEHLFUH.js";
import {
  __name,
  __objRest,
  __spreadProps,
  __spreadValues,
  __toESM
} from "./chunk-B36FS7SS.js";

// components/VulcanComponents/bootstrapCoreComponents.ts
import { defaultCoreComponents } from "@vulcanjs/react-ui";

// components/bootstrap/Dropdown.tsx
var import_prop_types = __toESM(require_prop_types(), 1);
import React from "react";
import { Dropdown, DropdownButton } from "react-bootstrap";
import { useVulcanComponents } from "@vulcanjs/react-ui";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var DropdownItem = Dropdown.Item;
var Item = /* @__PURE__ */ __name((_a) => {
  var _b = _a, {
    index,
    labelId,
    label,
    component,
    componentProps = {},
    itemProps
  } = _b, rest = __objRest(_b, [
    "index",
    "labelId",
    "label",
    "component",
    "componentProps",
    "itemProps"
  ]);
  const Components = useVulcanComponents();
  let menuComponent;
  if (component) {
    menuComponent = /* @__PURE__ */ React.cloneElement(component, componentProps);
  } else if (labelId) {
    menuComponent = /* @__PURE__ */ React.createElement(Components.FormattedMessage, {
      id: labelId
    });
  } else {
    menuComponent = /* @__PURE__ */ React.createElement("span", null, label);
  }
  const item = /* @__PURE__ */ React.createElement(DropdownItem, _extends({
    eventKey: index
  }, itemProps, rest), menuComponent);
  return item;
}, "Item");
Item.propTypes = {
  index: import_prop_types.default.number,
  to: import_prop_types.default.any,
  labelId: import_prop_types.default.string,
  label: import_prop_types.default.string,
  component: import_prop_types.default.object,
  componentProps: import_prop_types.default.object,
  itemProps: import_prop_types.default.object
};
var Node = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { childrenItems } = _b, rest = __objRest(_b, ["childrenItems"]);
  return /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(Item, _extends({}, rest)), childrenItems && !!childrenItems.length && /* @__PURE__ */ React.createElement("div", {
    className: "menu-node-children"
  }, childrenItems.map((item, index) => /* @__PURE__ */ React.createElement(Item, _extends({
    key: index
  }, item)))));
}, "Node");
Node.propTypes = {
  childrenItems: import_prop_types.default.array
};
var BootstrapDropdown = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { label, labelId, trigger, menuItems, menuContents, variant = "dropdown", buttonProps } = _b, dropdownProps = __objRest(_b, ["label", "labelId", "trigger", "menuItems", "menuContents", "variant", "buttonProps"]);
  const Components = useVulcanComponents();
  const menuBody = menuContents ? menuContents : menuItems.map((item, index) => {
    if (item === "divider") {
      return /* @__PURE__ */ React.createElement(Dropdown.Divider, {
        key: index
      });
    } else {
      return /* @__PURE__ */ React.createElement(Node, _extends({}, item, {
        key: index,
        index
      }));
    }
  });
  if (variant === "flat") {
    return menuBody;
  } else {
    if (trigger) {
      return /* @__PURE__ */ React.createElement(Dropdown, _extends({}, dropdownProps), /* @__PURE__ */ React.createElement(Dropdown.Toggle, null, trigger), /* @__PURE__ */ React.createElement(Dropdown.Menu, null, menuBody));
    } else {
      return /* @__PURE__ */ React.createElement(DropdownButton, _extends({}, buttonProps, {
        title: labelId ? /* @__PURE__ */ React.createElement(Components.FormattedMessage, {
          id: labelId
        }) : label
      }, dropdownProps), menuBody);
    }
  }
}, "BootstrapDropdown");
BootstrapDropdown.propTypes = {
  labelId: import_prop_types.default.string,
  label: import_prop_types.default.string,
  trigger: import_prop_types.default.object,
  menuContents: import_prop_types.default.object,
  menuItems: import_prop_types.default.array,
  variant: import_prop_types.default.string,
  buttonProps: import_prop_types.default.object
};
var Dropdown_default = BootstrapDropdown;

// components/bootstrap/Modal.tsx
var import_prop_types2 = __toESM(require_prop_types(), 1);
import React2 from "react";
import { Modal } from "react-bootstrap";
function _extends2() {
  _extends2 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends2.apply(this, arguments);
}
__name(_extends2, "_extends");
var BootstrapModal = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { children, size = "lg", show = false, onHide, title, showCloseButton = true, header, footer } = _b, rest = __objRest(_b, ["children", "size", "show", "onHide", "title", "showCloseButton", "header", "footer"]);
  let headerComponent;
  if (header) {
    headerComponent = /* @__PURE__ */ React2.createElement(Modal.Header, null, header);
  } else if (title) {
    headerComponent = /* @__PURE__ */ React2.createElement(Modal.Header, {
      closeButton: showCloseButton
    }, /* @__PURE__ */ React2.createElement(Modal.Title, null, title));
  } else {
    headerComponent = /* @__PURE__ */ React2.createElement(Modal.Header, {
      closeButton: showCloseButton
    });
  }
  const footerComponent = footer ? /* @__PURE__ */ React2.createElement(Modal.Footer, null, footer) : null;
  return /* @__PURE__ */ React2.createElement(Modal, _extends2({
    size,
    show,
    onHide
  }, rest), headerComponent, /* @__PURE__ */ React2.createElement(Modal.Body, null, children), footerComponent);
}, "BootstrapModal");
BootstrapModal.propTypes = {
  size: import_prop_types2.default.string,
  show: import_prop_types2.default.bool,
  showCloseButton: import_prop_types2.default.bool,
  onHide: import_prop_types2.default.func,
  title: import_prop_types2.default.oneOfType([
    import_prop_types2.default.string,
    import_prop_types2.default.element
  ]),
  header: import_prop_types2.default.oneOfType([
    import_prop_types2.default.string,
    import_prop_types2.default.element
  ]),
  footer: import_prop_types2.default.oneOfType([
    import_prop_types2.default.string,
    import_prop_types2.default.element
  ])
};

// components/bootstrap/ModalTrigger.tsx
import React3, { useState } from "react";
import { useVulcanComponents as useVulcanComponents2 } from "@vulcanjs/react-ui";
function _extends3() {
  _extends3 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends3.apply(this, arguments);
}
__name(_extends3, "_extends");
var ModalTrigger = /* @__PURE__ */ __name((props) => {
  const [modalIsOpen, setModalIsOpen] = useState(false);
  const { onClick, openCallback, closeCallback } = props;
  const clickHandler = /* @__PURE__ */ __name((e) => {
    e.preventDefault();
    if (onClick) {
      onClick();
    }
    openModal();
  }, "clickHandler");
  const openModal = /* @__PURE__ */ __name(() => {
    if (openCallback) {
      openCallback();
    }
    setModalIsOpen(true);
  }, "openModal");
  const closeModal = /* @__PURE__ */ __name(() => {
    if (closeCallback) {
      closeCallback();
    }
    setModalIsOpen(false);
  }, "closeModal");
  const Components = useVulcanComponents2();
  const { trigger, component, children, label, size, className, dialogClassName, title, modalProps, header, footer } = props;
  let triggerComponent = trigger || component;
  triggerComponent = triggerComponent ? /* @__PURE__ */ React3.createElement("span", {
    onClick: clickHandler
  }, triggerComponent) : /* @__PURE__ */ React3.createElement(Components.Button, {
    onClick: clickHandler
  }, label);
  const childrenComponent = /* @__PURE__ */ React3.cloneElement(children, {
    closeModal
  });
  const headerComponent = header && /* @__PURE__ */ React3.cloneElement(header, {
    closeModal
  });
  const footerComponent = footer && /* @__PURE__ */ React3.cloneElement(footer, {
    closeModal
  });
  return /* @__PURE__ */ React3.createElement("div", {
    className: "modal-trigger"
  }, triggerComponent, /* @__PURE__ */ React3.createElement(Components.Modal, _extends3({
    size,
    className,
    show: modalIsOpen,
    onHide: closeModal,
    dialogClassName,
    title,
    header: headerComponent,
    footer: footerComponent
  }, modalProps), childrenComponent));
}, "ModalTrigger");

// components/VulcanComponents/bootstrapCoreComponents.ts
import { liteCoreComponents } from "@vulcanjs/react-ui-lite";
var bootstrapCoreComponents = __spreadProps(__spreadValues(__spreadValues({}, defaultCoreComponents), liteCoreComponents), {
  FormattedMessage,
  Alert,
  Button,
  TooltipTrigger,
  Dropdown: Dropdown_default,
  ModalTrigger,
  Modal: BootstrapModal
});

export {
  bootstrapCoreComponents
};
//# sourceMappingURL=chunk-MLWYQC2D.js.map